#!/usr/bin/bash

# ************************************************************
# Inicia parámetros definidos por usuario
blenderVer=blender350
ruta=/home/braquistos/Documentos/practicas/blenders/renderPartes/
archBlend=prueba.blend
archTiles='figura%03d.png'
W=1920
H=1080
celdas=40
render=False
# Termina parámetros definidos por usuario
# ************************************************************


# ************************************************************
#                  AYUDA
# blenderVer = Ejecutable y su ruta si corresponde.
#
#       ruta = Ruta del archivo *.blend que se va a renderizar. Allí mismo se
#              colocarán las imágenes de salida.
#
#  archBlend = Nombre del archivo de Blender a renderizar.
#
#  archTiles = nombre genérico de las imágenes de salida. En el ejemplo la
#              notación '%03d' significa que las imágenes van a salir numeradas
#              con tres dígitos y los nombres de los archivos será de la forma
#              imagen001.png, imagen002.png, etc.
#
#          W = Ancho de la imagen en pixeles. Equivale a la 'Resolution X' del
#              panel Output properties de Blender, suponiendo que el porcentaje
#              es de 100 % del tamaño. De lo contrario hay que poner el valor
#              que le corresponde.
#
#          H = Altura de la imagen en pixeles. Mismo caso que el anterior,
#              pero para Y.
#
#     celdas = Cantidad de celdas o imágenes de salida. Dado que las celdas
#              son cuadradas este valor es sólo el valor más aproximado.
#
#     render = Con esto se indica si se quiere o no hacer el render. Esta
#              variable es de utilidad puesto que en caso de que sea 'False' se
#              proporciona información de salida de interés antes de llevar a
#              cabo propiamente el render cuando render=True. También es de
#              utilidad para ver que funciona bien. Nota: el mensaje que
#              aparece al final: "Error: File path '/ruta/x' invalid" no
#              influye en el funcionamiento del script.
# ************************************************************

rutaArchBlend=$ruta$archBlend

$blenderVer $rutaArchBlend --background --python renderPartes.py $ruta $archTiles $W $H $celdas $render
